<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>WorkdayCalculator (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="WorkdayCalculator (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/WorkdayCalculator.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../../org/apache/poi/ss/formula/atp/DateParser.html"
               title="class in org.apache.poi.ss.formula.atp"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li>Next&nbsp;Class</li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../../index.html?org/apache/poi/ss/formula/atp/WorkdayCalculator.html" target="_top">Frames</a>
        </li>
        <li><a href="WorkdayCalculator.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ss.formula.atp</div>
    <h2 title="Class WorkdayCalculator" class="title">Class WorkdayCalculator</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.ss.formula.atp.WorkdayCalculator</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <hr>
                <br>
                <pre>public class <span class="typeNameLabel">WorkdayCalculator</span>
extends java.lang.Object</pre>
                <div class="block">A calculator for workdays, considering dates as excel representations.</div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- =========== FIELD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.summary">
                        <!--   -->
                    </a>
                        <h3>Field Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Field Summary table, listing fields, and an explanation">
                            <caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Field and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>static <a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html"
                                        title="class in org.apache.poi.ss.formula.atp">WorkdayCalculator</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html#instance">instance</a></span></code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html#calculateNonWeekendHolidays-double-double-double:A-">calculateNonWeekendHolidays</a></span>(double&nbsp;start,
                                    double&nbsp;end,
                                    double[]&nbsp;holidays)</code>
                                    <div class="block">Calculates how many holidays in a list are workdays, considering
                                        an interval of dates.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html#calculateWorkdays-double-double-double:A-">calculateWorkdays</a></span>(double&nbsp;start,
                                    double&nbsp;end,
                                    double[]&nbsp;holidays)</code>
                                    <div class="block">Calculate how many workdays are there between a start and an end
                                        date, as excel representations, considering a range of holidays.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>java.util.Date</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html#calculateWorkdays-double-int-double:A-">calculateWorkdays</a></span>(double&nbsp;start,
                                    int&nbsp;workdays,
                                    double[]&nbsp;holidays)</code>
                                    <div class="block">Calculate the workday past x workdays from a starting date,
                                        considering a range of holidays.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>protected boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html#isHoliday-double-double:A-">isHoliday</a></span>(double&nbsp;aDate,
                                    double[]&nbsp;holidays)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>protected boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html#isInARange-double-double-double-">isInARange</a></span>(double&nbsp;start,
                                    double&nbsp;end,
                                    double&nbsp;aDate)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>protected boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html#isWeekend-double-">isWeekend</a></span>(double&nbsp;aDate)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html#pastDaysOfWeek-double-double-int-">pastDaysOfWeek</a></span>(double&nbsp;start,
                                    double&nbsp;end,
                                    int&nbsp;dayOfWeek)</code>
                                    <div class="block">Calculates how many days of week past between a start and an end
                                        date.
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ FIELD DETAIL =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.detail">
                        <!--   -->
                    </a>
                        <h3>Field Detail</h3>
                        <a name="instance">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>instance</h4>
                                <pre>public static final&nbsp;<a
                                        href="../../../../../../org/apache/poi/ss/formula/atp/WorkdayCalculator.html"
                                        title="class in org.apache.poi.ss.formula.atp">WorkdayCalculator</a> instance</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="calculateWorkdays-double-double-double:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>calculateWorkdays</h4>
                                <pre>public&nbsp;int&nbsp;calculateWorkdays(double&nbsp;start,
                             double&nbsp;end,
                             double[]&nbsp;holidays)</pre>
                                <div class="block">Calculate how many workdays are there between a start and an end
                                    date, as excel representations, considering a range of holidays.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>start</code> - start date.</dd>
                                    <dd><code>end</code> - end date.</dd>
                                    <dd><code>holidays</code> - an array of holidays.</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>number of workdays between start and end dates, including both dates.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="calculateWorkdays-double-int-double:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>calculateWorkdays</h4>
                                <pre>public&nbsp;java.util.Date&nbsp;calculateWorkdays(double&nbsp;start,
                                        int&nbsp;workdays,
                                        double[]&nbsp;holidays)</pre>
                                <div class="block">Calculate the workday past x workdays from a starting date,
                                    considering a range of holidays.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>start</code> - start date.</dd>
                                    <dd><code>workdays</code> - number of workdays to be past from starting date.</dd>
                                    <dd><code>holidays</code> - an array of holidays.</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>date past x workdays.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="pastDaysOfWeek-double-double-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>pastDaysOfWeek</h4>
                                <pre>protected&nbsp;int&nbsp;pastDaysOfWeek(double&nbsp;start,
                             double&nbsp;end,
                             int&nbsp;dayOfWeek)</pre>
                                <div class="block">Calculates how many days of week past between a start and an end
                                    date.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>start</code> - start date.</dd>
                                    <dd><code>end</code> - end date.</dd>
                                    <dd><code>dayOfWeek</code> - a day of week as represented by <code>Calendar</code>
                                        constants.
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>how many days of week past in this interval.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="calculateNonWeekendHolidays-double-double-double:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>calculateNonWeekendHolidays</h4>
                                <pre>protected&nbsp;int&nbsp;calculateNonWeekendHolidays(double&nbsp;start,
                                          double&nbsp;end,
                                          double[]&nbsp;holidays)</pre>
                                <div class="block">Calculates how many holidays in a list are workdays, considering an
                                    interval of dates.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>start</code> - start date.</dd>
                                    <dd><code>end</code> - end date.</dd>
                                    <dd><code>holidays</code> - an array of holidays.</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>number of holidays that occur in workdays, between start and end dates.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isWeekend-double-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>isWeekend</h4>
                                <pre>protected&nbsp;boolean&nbsp;isWeekend(double&nbsp;aDate)</pre>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>aDate</code> - a given date.</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd><code>true</code> if date is weekend, <code>false</code> otherwise.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isHoliday-double-double:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>isHoliday</h4>
                                <pre>protected&nbsp;boolean&nbsp;isHoliday(double&nbsp;aDate,
                            double[]&nbsp;holidays)</pre>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>aDate</code> - a given date.</dd>
                                    <dd><code>holidays</code> - an array of holidays.</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd><code>true</code> if date is a holiday, <code>false</code> otherwise.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isInARange-double-double-double-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>isInARange</h4>
                                <pre>protected&nbsp;boolean&nbsp;isInARange(double&nbsp;start,
                             double&nbsp;end,
                             double&nbsp;aDate)</pre>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>start</code> - start date.</dd>
                                    <dd><code>end</code> - end date.</dd>
                                    <dd><code>aDate</code> - a date to be analyzed.</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd><code>true</code> if aDate is between start and end dates, <code>false</code>
                                        otherwise.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/WorkdayCalculator.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../../org/apache/poi/ss/formula/atp/DateParser.html"
               title="class in org.apache.poi.ss.formula.atp"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li>Next&nbsp;Class</li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../../index.html?org/apache/poi/ss/formula/atp/WorkdayCalculator.html" target="_top">Frames</a>
        </li>
        <li><a href="WorkdayCalculator.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
